---
- name: GitLab playbook-idm
  ansible.builtin.import_tasks: add_project.yml
  vars:
    - project_name: GitLab playbook-idm
    - project_url: https://gitlab.com/ansible-ssa/playbook-idm.git

- name: Create Deploy IdM Instance - Job Template
  ansible.controller.job_template:
    name: Red Hat IdM - Deploy new Instance on EC2
    ask_variables_on_launch: true
    state: present
    inventory: ec2
    credentials: ec2
    job_type: run
    playbook: idm-instance.yml
    project: GitLab playbook-idm
    ask_credential_on_launch: true
    ask_inventory_on_launch: true
    survey_enabled: true
    survey_spec: "{{ lookup('template', 'idm-instance-survey-ec2.json.j2') }}"
    extra_vars:
      ec2_vpc_name: "{{ ec2_vpc_name | default(omit) }}"
    execution_environment: '{{ "ee-ansible-ssa" if controller_ah_enable | bool else "Default execution environment" }}'

- name: Install IdM Server - Job Template
  ansible.controller.job_template:
    name: Red Hat IdM - Setup IdM on EC2
    ask_variables_on_launch: true
    state: present
    inventory: ec2
    credentials: ansible-ec2
    ask_inventory_on_launch: true
    job_type: run
    playbook: idm-setup.yml
    project: GitLab playbook-idm
    ask_limit: true
    limit: idmsrv
    ask_credential_on_launch: true
    survey_enabled: true
    survey_spec: "{{ lookup('template', 'idm-setup-survey.json.j2') }}"
    execution_environment: '{{ "ee-ansible-ssa" if controller_ah_enable | bool else "Default execution environment" }}'

- name: Create a Red Hat IdM workflow job template
  ansible.controller.workflow_job_template:
    name: Red Hat IdM - Complete Workflow on EC2
    description: created by Ansible Playbook
    organization: Default

- name: Create Setup IdM workflow node
  ansible.controller.workflow_job_template_node:
    identifier: setup-node
    workflow: Red Hat IdM - Complete Workflow on EC2
    unified_job_template: Red Hat IdM - Setup IdM on EC2
    organization: Default

- name: Create Deploy instance for IdM workflow node
  ansible.controller.workflow_job_template_node:
    identifier: deploy-node
    workflow: Red Hat IdM - Complete Workflow on EC2
    unified_job_template: Red Hat IdM - Deploy new Instance on EC2
    organization: Default
    success_nodes:
      - setup-node
